Scriptname AAFlyScriptBCompanion extends activemagiceffect
  
import utility
import game
import debug
import Math
import input
import NetImmerse
import sound
import Actor
Actor Target
Actor Player
Actor CTar
perk property CNoFD auto
float posx
float posy
float posz
float dirx
float diry
float dirz
float bearing
float elevation
float Heading
float Speed
float Distance
float tarx
float tary
float tarz
float tardist
float tarhead
int fw
int bck
int lft
int rgt
int up
int down
int CombatSty
int SpSw
spell[] property RandAttacks auto
;1 -- 1h
;2 -- dual
;3 -- Shield
;4 -- 2h
;5 -- Magic
bool NonEss
int property Check = 0x15 auto
float NumComp
GlobalVariable property FlyingToggle auto
GlobalVariable property CompAm auto

auto State Idle
	Event OnEffectStart(Actor akCaster, Actor akTarget)
		Target = akCaster
		Player = akTarget
		Target.AddPerk(CNoFD)
		CompAm.SetValue(CompAm.GetValue() + 1)
		fw = GetMappedKey("Forward")
		bck = getMappedKey("back")
		lft = GetMappedKey("Strafe Left")
		rgt = GetMappedKey("Strafe Right")
		up = GetMappedKey("Jump")
		down = GetMappedKey("Sneak")
		NumComp = CompAm.GetValue()
		SetIniFloat("fInAirFallingCharGravityMult:Havok",0)
		if FlyingToggle.GetValue() == 1
			sendAnimationEvent(target,"eFlyingIdle")
			
		else
			Notification("You must be flying in order for your companions to fly")
		endif
		GoToState("Idle")
	EndEvent
	Event OnBeginState()
		While FlyingToggle.GetValue() == 1 && !Target.IsDead()
			bearing = Player.GetAngleZ()
			Elevation = Player.GetAngleX()
			If NumComp == 1
				posx = Player.GetPositionX() + (sin(bearing + 90)*100)
				posy = Player.GetPositionY() + (cos(Bearing + 90)*100)
				Distance = 110
			elseif NumComp == 2
				posx = Player.GetPositionX() + (sin(bearing - 90)*100)
				posy = Player.GetPositionY() + (cos(Bearing - 90)*100)
				Distance = 110
			elseif NumComp == 3
				posx = Player.GetPositionX() - (sin(bearing)*100)
				posy = Player.GetPositionY() - (cos(Bearing)*100)
				Distance = 110
			elseif NumComp == 4
				posx = Player.GetPositionX() - ((sin(bearing) + (sin(bearing - 90)))*200)
				posy = Player.GetPositionY() - ((cos(Bearing) + (cos(Bearing - 90)))*200)
				Distance = 310
			elseif NumComp == 5
				posx = Player.GetPositionX() - ((sin(bearing) + (sin(bearing + 90)))*200)
				posy = Player.GetPositionY() - ((cos(Bearing) + (cos(Bearing + 90)))*200)
				Distance = 310
			endIf
			posz = Player.GetPositionZ()
			if Target.GetCombatState() == 1
				GoToState("SelectWeapon")
			endIf
			If Player.GetDistance(Target) > Distance 
				Speed = Player.GetDistance(Target)
				if IsKeyPressed(fw)
					if Elevation > 15
						SendAnimationEvent(Target,"eFlyingForwardUp")
					elseif Elevation < -15
						sendAnimationEvent(Target,"eFlyingForwardDown")
					else
						SendAnimationEvent(Target,"eFlyingForward")
					endif
				elseif IskeyPressed(bck)
					SendAnimationEvent(Target,"eFlyingBack")
				elseif IsKeyPressed(lft)
					sendAnimationEvent(Target,"eFlyingLeft")
				elseif IsKeyPressed(rgt)
					sendAnimationEvent(Target,"eFlyingRight")
				elseif IskeyPressed(up)
					sendAnimationEvent(Target,"eFlyingUp")
					Speed = 500
				elseif IsKeyPressed(down)
					Speed = 500
					sendAnimationEvent(Target,"eFlyingDown")
				endIf
				Target.TranslateTo(posx,posy,posz,elevation,0,Bearing,Speed)
			else
				sendAnimationEvent(Target,"eFlyingIdle")
			endIf
			
		endWhile
		If FlyingToggle.GetValue() == 1
			CompAm.SetValue(CompAm.GetValue() - 1)
			sendAnimationEvent(Target, "DeathAnim")
			Wait(5)
			;Target.RemovePerk(CNoFD)
		else
			SetIniFloat("fInAirFallingCharGravityMult:Havok",1.35)
			SendAnimationEvent(Target,"IdleForceDefaultState")
			CompAm.SetValue(0)
			
			If !Target.IsEssential()
				Target.GetActorBase().SetEssential(true)
				Notification("Yay")
				Wait(10)
				Target.GetActorBase().SetEssential(false)
			endIf
		endIf
	EndEvent
endState

State SelectWeapon
	Event OnBeginState()
		Weapon EqWeap = Target.GetEquippedWeapon()
		float basedmg = EqWeap.GetBaseDamage()
		if basedmg >= 10 && basedmg < 20
			SpSw = 0
		elseif basedmg >= 20 && basedmg < 30
			SpSw = 1
		elseif basedmg >= 30 && basedmg < 40
			SpSw = 2
		elseif basedmg >= 40 && basedmg < 50
			SpSw = 3
		elseif basedmg >= 50 && basedmg < 60
			SpSw = 4
		elseif basedmg >= 60
			SpSw = 5
		endIf
		GoToState("Combat")
	endEvent
endState

State Combat
	Event OnBeginState()
	
		While Target.GetCombatState() == 1
			sendAnimationEvent(Target,"eFlyingForward")
			CTar = Target.GetCombatTarget()

			If NumComp == 1
				tarx = CTar.GetPositionX() + 500
				tary = CTar.GetPositionY() 
			elseif NumComp == 2
				tarx = CTar.GetPositionX() 
				tary = CTar.GetPositionY() + 500

			elseif NumComp == 3
				tarx = CTar.GetPositionX() - 500
				tary = CTar.GetPositionY() 

			elseif NumComp == 4
				tarx = CTar.GetPositionX() + 500
				tary = CTar.GetPositionY() - 500

			elseif NumComp == 5
				tarx = CTar.GetPositionX() - 500
				tary = CTar.GetPositionY() + 500

			endIf
			tarz = CTar.GetPositionZ() + 600
			
			tarDist = Target.GetDistance(CTar)
			if tarDist > 1000
				sendAnimationEvent(Target,"eFlyingForward")
				float bear = Target.GetAngleZ()
				float elev = Target.GetAngleX()
				Target.TranslateTo(tarx,tary,tarz,elev,0,bear,tarDist/2)
			else
				float bear = Target.GetAngleZ()
				float elev = Target.GetAngleX()
				Target.TranslateTo(Target.X,Target.Y,Target.Z,elev,0,bear,100)
				RandAttacks[randomInt(0,4)].Cast(Target)
				sendAnimationEvent(Target,"eFlyingAttackDual")
				Wait(2)
			endIf
			if Target.IsDead()
				GoToState("Idle")
			endIf
		endWhile
		GoToState("Idle")
	endEvent
endState