Scriptname __FlyingConfig extends activemagiceffect  

GlobalVariable property FlyingEffects auto
GlobalVariable property FlyingCollisions auto
GlobalVariable property FlyingSpeed auto
GlobalVariable Property FlyingStamina auto
GlobalVariable property FlyingTakeOffEvent auto
GlobalVariable property DSouls auto
Message property FlyingMainMenu auto
Message property FFEffects auto
Message property CollisionMenu auto
Message property SpeedMenu auto
Message Property StaminaMenu Auto
Message Property TakeOffMenu auto
Message property DSoulsMenu auto
int STButton
int MMButton
int EFButton
int COButton
int SPButton
int TOButton
int DSButton
Event OnEffectStart(actor akTarget, actor akCaster)
	FlyingMenu()
endEvent

function FlyingMenu()
	MMButton = FlyingMainMenu.show()
	if MMButton == 0
		Speed()
	elseif MMButton == 1
		Stamina()
	elseif MMButton == 2
		BCollisions()
	elseif MMButton == 3
		FEffects()
	elseif MMButton == 4
		DSoulM()
	endIf
endFunction

Function DSoulM()
	DSButton = DSoulsMenu.Show()
	if DSButton == 0
		DSouls.SetValue(0)
	elseif DSButton == 1
		DSouls.SetValue(1)
	elseif DSButton == 2
		FlyingMenu()
	endIF
endFunction
		
	
function Speed()

	SPButton = SpeedMenu.Show()
	if SPButton == 0
		FlyingSpeed.SetValue(-3)
	elseif SPButton == 1
		FlyingSpeed.SetValue(-2)
	elseif SPButton == 2
		FlyingSpeed.SetValue(-1)
	elseif SPButton == 3
		FlyingSpeed.SetValue(0)
	elseIf SPButton == 4
		FlyingSpeed.SetValue(1)
	elseif SPButton == 5
		FlyingSpeed.SetValue(2)
	elseif SPButton == 6
		FlyingSpeed.SetValue(3)
	elseif SPButton == 7
		FlyingMenu()
	endIf
	
endFunction

function Stamina()
	
	STButton = StaminaMenu.Show()
	if STButton == 0
		FlyingStamina.SetValue(0)
	elseif STButton == 1
		FlyingStamina.SetValue(1)
	elseIf STButton == 2
		FlyingStamina.SetValue(2)
	elseif STButton == 3
		FlyingStamina.SetValue(3)
	elseif STButton == 4
		FlyingMenu()
	endIf
	
endfunction

function BCollisions()

	COButton = CollisionMenu.Show()
	if COButton == 0
		FlyingCollisions.SetValue(0)
	elseif COButton == 1
		FlyingCollisions.SetValue(1)
	elseif COButton == 2
		FlyingMenu()
	endIf
	
endFunction

function FEffects()

	EFButton = FFEffects.Show()
	if EFButton == 0
		FlyingEffects.SetValue(0)
	elseif EFButton == 1
		FlyingEffects.SetValue(1)
	elseif EFButton == 2
		FlyingEffects.SetValue(2)
	elseif EFButton == 3	
		FlyingEffects.SetValue(3)
	elseif EFButton == 4
		FlyingEffects.SetValue(4)
	elseif EFButton == 5
		FlyingEffects.SetValue(5)
	elseif EFButton == 6
		FlyingEffects.SetValue(6)
	elseif EFButton == 7
		FlyingMenu()
	endIF
	
endFunction
